local _, QTip = ...
QTip.Frames = {}
QTip.Functions = {}
QTip.Events = {}
QTip.Data = {}
function QTip.Functions.CreateData()
local PlayerID = UnitGUID("player")
if ((QTipPerDB and QTipPerDB.PlayerID) and (QTipPerDB.PlayerID ~= PlayerID)) then QTipPerDB = nil; end
if (not QTipPerDB) then QTipPerDB = {}; end
if (not QTipPerDB.PlayerID) then QTipPerDB.PlayerID = PlayerID; end
if (not QTipPerDB.Enabled) then QTipPerDB.Enabled = {}; end
if (QTipPerDB.Enabled.Anima == nil) then QTipPerDB.Enabled.Anima = true; end
if (QTipPerDB.Enabled.EquipQ == nil) then QTipPerDB.Enabled.EquipQ = true; end
if (QTipPerDB.Enabled.EquipT == nil) then QTipPerDB.Enabled.EquipT = true; end
if (QTipPerDB.Enabled.EquipR == nil) then QTipPerDB.Enabled.EquipR = true; end
if (QTipPerDB.Enabled.EquipB == nil) then QTipPerDB.Enabled.EquipB = true; end
if (QTipPerDB.Enabled.EquipA == nil) then QTipPerDB.Enabled.EquipA = true; end
QTip.Data.SetAnima = true
end
function QTip.Functions.Update_Anima(Action, Self)
local TooltipName
if (Action == 1) then TooltipName = "GameTooltipTooltipTextLeft"; else TooltipName = "GameTooltipTextLeft"; end
if (not QTip.Data.TooltipData) then
for i = 1, Self:NumLines() do
local Text = _G[TooltipName..i]:GetText()
if (i == 2) then QTipPerDB.Anima = Text; end
if (string.match(Text, "%f[%a]"..WORLD_QUEST_REWARD_FILTERS_ANIMA.."%f[%A]") and string.match(Text, USE_COLON)) then
if (Action == 1) then
local Value = string.match(Text, "%d+")
if (QTip.Data.SetAnima) then
local Amount
for k, v in pairs({GameTooltip:GetChildren()}) do
if (v.count) then
Amount = v.count
break
end
end
if (Amount and Amount > 1) then
local NewValue = Value * Amount
local Display = string.gsub(Text, Value, NewValue)
QTip.Data.TooltipData = {1, i, Display}
end
else
QTip.Data.TooltipData = {2, i, Text, Value}
end
elseif (Action == 2) then
local Owner = Self:GetOwner()
local Amount = Owner.count
if (not Amount and Owner.Quantity and (CovenantMissionFrame:IsShown() or GarrisonLandingPage:IsShown())) then Amount = tonumber(Owner.Quantity:GetText()); end
if (Amount and Amount > 1) then
local Value = string.match(Text, "%d+")
local NewValue = Value * Amount
local Display = string.gsub(Text, Value, NewValue)
QTip.Data.TooltipData = {3, i, Display}
end
end
break
end
end
end
if (QTip.Data.TooltipData) then
if (QTip.Data.TooltipData[1] == 1) then QTip.Data.SetAnima = nil; end
_G[TooltipName..QTip.Data.TooltipData[2]]:SetText(QTip.Data.TooltipData[3])
end
end
function QTip.Functions.HideLines()
for _, v in pairs(QTip.Frames.Lines) do
for _, vv in pairs(v) do vv:SetShown(false) end
end
end
function QTip.Functions.Update_Equipment(Action, Self)
local TooltipName
if (Action == 1) then TooltipName = "GameTooltipTooltip"; else TooltipName = "GameTooltip"; end
if (not QTip.Data.TooltipData) then
local cValue = GetCVarBool("allowCompareWithToggle")
SetCVar("allowCompareWithToggle", false)
if (Action == 1) then GameTooltip_ShowCompareItem(GameTooltipTooltip); else GameTooltip_ShowCompareItem(); end
SetCVar("allowCompareWithToggle", cValue)
local Stats = {[1] = {["Stats"] = {}, ["Multi"] = false}, [2] = {["Stats"] = {}, ["Multi"] = false}}
for i = 1, 2 do
local Tooltip = _G["ShoppingTooltip"..i]
if (Tooltip:NumLines() > 0) then
local CName, CLink = Tooltip:GetItem()
local Color = string.match(CLink, "%|c(.-)%|H")
table.insert(Stats[i].Stats, "|cff717173"..CURRENTLY_EQUIPPED)
table.insert(Stats[i].Stats, "|c"..Color..CName)
end
local Index
for x = 1, Tooltip:NumLines() do
local Text = _G[Tooltip:GetName().."TextLeft"..x]:GetText()
if (string.match(Text, STAT_AVERAGE_ITEM_LEVEL)) then table.insert(Stats[i].Stats, "|cffffe00a"..Text); end
if (not Index and (Text == ITEM_DELTA_DESCRIPTION or Text == ITEM_DELTA_MULTIPLE_COMPARISON_DESCRIPTION)) then
table.insert(Stats[i].Stats, " ")
table.insert(Stats[i].Stats, "|cffffe00a"..Text)
if (Text == ITEM_DELTA_MULTIPLE_COMPARISON_DESCRIPTION) then Stats[i].Multi = true; end
Index = x
end
if (Index and (x > Index)) then table.insert(Stats[i].Stats, Text); end
end
end
if (Stats[1].Multi and not Stats[2].Multi) then
local Temp = Stats[1]
Stats[1] = Stats[2]
Stats[2] = Temp
end
if (#Stats[1].Stats > 0 or #Stats[2].Stats > 0) then QTip.Data.TooltipData = {4, Stats}; end
end
if (QTip.Data.TooltipData and QTip.Data.TooltipData[1] == 4) then
local CenterOffset, Top, Center, Bottom = 0
Self:AddLine(" ")
Self:AddDoubleLine(" ", " ")
Top = Self:NumLines()
for i = 1, 2 do
for x = 1, #QTip.Data.TooltipData[2][i].Stats do Self:AddLine(QTip.Data.TooltipData[2][i].Stats[x], 1, 1, 1, 1) end
if (i == 1 and #QTip.Data.TooltipData[2][2].Stats > 0) then
Self:AddDoubleLine(" ", " ")
Center = Self:NumLines()
Self:AddLine(" ")
end
end
Self:AddDoubleLine(" ", " ")
Bottom = Self:NumLines()
if (Top and Bottom) then
QTip.Frames.Lines[Action].Top:SetStartPoint("LEFT", _G[TooltipName.."TextLeft"..Top], 0, 0)
QTip.Frames.Lines[Action].Top:SetEndPoint("RIGHT", _G[TooltipName.."TextRight"..Top], 0, 0)
QTip.Frames.Lines[Action].Top:Show()
QTip.Frames.Lines[Action].Bottom:SetStartPoint("LEFT", _G[TooltipName.."TextLeft"..Bottom], 0, 0)
QTip.Frames.Lines[Action].Bottom:SetEndPoint("RIGHT", _G[TooltipName.."TextRight"..Bottom], 0, 0)
QTip.Frames.Lines[Action].Bottom:Show()
end
if (Center) then
QTip.Frames.Lines[Action].Center:SetStartPoint("BOTTOMLEFT", _G[TooltipName.."TextLeft"..Center], 0, -1)
QTip.Frames.Lines[Action].Center:SetEndPoint("BOTTOMRIGHT", _G[TooltipName.."TextRight"..Center], 0, -1)
QTip.Frames.Lines[Action].Center:Show()
end
else
QTip.Functions.HideLines()
end
end
function QTip.Functions.UpdateTooltip()
if (QTip.Data.TooltipData and QTip.Data.TooltipData[1] == 2 and not QTip.Data.SetAnima) then
local Amount = GameTooltip.ItemTooltip.count
if (Amount > 1) then
local NewValue = QTip.Data.TooltipData[4] * Amount
local Display = string.gsub(QTip.Data.TooltipData[3], QTip.Data.TooltipData[4], NewValue)
_G["GameTooltipTooltipTextLeft"..QTip.Data.TooltipData[2]]:SetText(Display)
end
end
end
function QTip.Functions.CreateOptions()
local Title = QTip.Frames.Options:CreateFontString("ARTWORK")
Title:SetFontObject("GameFontNormalLarge")
Title:SetPoint("TOPLEFT", 16, -16)
Title:SetText(QTip.Data.Title.." v"..QTip.Data.Version)
local Slash = QTip.Frames.Options:CreateFontString("ARTWORK")
Slash:SetFontObject("GameFontNormal")
Slash:SetFont("Fonts\\FRIZQT__.TTF", 13)
Slash:SetPoint("TOPLEFT", Title, "BOTTOMLEFT", 0, -16)
Slash:SetText("|cffffffffType |cfff8f996"..SLASH_QTIP1.."|cffffffff or |r"..SLASH_QTIP2.."|cffffffff to open options")
local OptionsBackground = CreateFrame("Frame", nil,  QTip.Frames.Options, BackdropTemplateMixin and "BackdropTemplate")
OptionsBackground:SetBackdrop({bgFile = nil, edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = {left = 4, right = 4, top = 4, bottom = 4},})
OptionsBackground:SetHeight(190)
OptionsBackground:SetPoint("TOPLEFT", QTipOptions, "TOPLEFT", 16, -120)
OptionsBackground:SetPoint("TOPRIGHT", QTipOptions, "TOPRIGHT", -16, -120)
local OptionsTitle1 = OptionsBackground:CreateFontString("ARTWORK")
OptionsTitle1:SetFontObject("GameFontNormalLarge")
OptionsTitle1:SetPoint("BOTTOM", OptionsBackground, "TOP", 0, 5)
OptionsTitle1:SetText("Enable Features")
local OptionsTitle2 = OptionsBackground:CreateFontString("ARTWORK")
OptionsTitle2:SetFontObject("GameFontNormalLarge")
OptionsTitle2:SetPoint("TOP", 0, -12)
OptionsTitle2:SetText("|cFF66BBFFAnima")
local OptionsTitle3 = OptionsBackground:CreateFontString("ARTWORK")
OptionsTitle3:SetFontObject("GameFontNormalLarge")
OptionsTitle3:SetPoint("TOP", OptionsTitle2, "BOTTOM", 0, -60)
OptionsTitle3:SetText("|cFF02df04Equipment Stats Comparison")
QTip.Frames.OptionButton = {}
local Text = {"Show Actual Anima Reward Amounts", "World Quests", "Command Table", "Sanctum Report", "Bags/Bank/Guild Bank", "Auction House"}
for i = 1, 6 do
QTip.Frames.OptionButton[i] = CreateFrame("CheckButton", nil, OptionsBackground, "InterfaceOptionsCheckButtonTemplate")
QTip.Frames.OptionButton[i].Text:SetFont("Fonts\\FRIZQT__.TTF", 13)
QTip.Frames.OptionButton[i].Text:SetText(Text[i])
QTip.Frames.OptionButton[i]:SetHitRectInsets(0, -QTip.Frames.OptionButton[i].Text:GetWidth(), 0, 0)
QTip.Frames.OptionButton[i]:SetScript("OnClick", function(Self) end)
end
QTip.Frames.OptionButton[1]:SetPoint("TOPLEFT", OptionsTitle2, "BOTTOMLEFT", -118, -5)
QTip.Frames.OptionButton[2]:SetPoint("TOPRIGHT", OptionsTitle3, "BOTTOMLEFT", -132, -5)
QTip.Frames.OptionButton[3]:SetPoint("TOP", OptionsTitle3, "BOTTOM", -67, -5)
QTip.Frames.OptionButton[4]:SetPoint("TOPLEFT", OptionsTitle3, "BOTTOMRIGHT", 21, -5)
QTip.Frames.OptionButton[5]:SetPoint("TOPRIGHT", OptionsTitle3, "BOTTOMLEFT", -142, -45)
QTip.Frames.OptionButton[6]:SetPoint("TOPLEFT", OptionsTitle3, "BOTTOMRIGHT", 39, -45)
function QTip.Frames.Options:refresh()
QTip.Frames.OptionButton[1]:SetChecked(QTipPerDB.Enabled.Anima)
QTip.Frames.OptionButton[2]:SetChecked(QTipPerDB.Enabled.EquipQ)
QTip.Frames.OptionButton[3]:SetChecked(QTipPerDB.Enabled.EquipT)
QTip.Frames.OptionButton[4]:SetChecked(QTipPerDB.Enabled.EquipR)
QTip.Frames.OptionButton[5]:SetChecked(QTipPerDB.Enabled.EquipB)
QTip.Frames.OptionButton[6]:SetChecked(QTipPerDB.Enabled.EquipA)
end
function QTip.Frames.Options:okay()
QTipPerDB.Enabled.Anima = QTip.Frames.OptionButton[1]:GetChecked()
QTipPerDB.Enabled.EquipQ = QTip.Frames.OptionButton[2]:GetChecked()
QTipPerDB.Enabled.EquipT = QTip.Frames.OptionButton[3]:GetChecked()
QTipPerDB.Enabled.EquipR = QTip.Frames.OptionButton[4]:GetChecked()
QTipPerDB.Enabled.EquipB = QTip.Frames.OptionButton[5]:GetChecked()
QTipPerDB.Enabled.EquipA = QTip.Frames.OptionButton[6]:GetChecked()
end
function QTip.Frames.Options:default()
QTipPerDB.Enabled.Anima = true
QTipPerDB.Enabled.EquipQ = true
QTipPerDB.Enabled.EquipT = true
QTipPerDB.Enabled.EquipR = true
QTipPerDB.Enabled.EquipB = true
QTipPerDB.Enabled.EquipA = true
end
end
function QTip.Functions.CreateFrames()
QTip.Frames.Lines = {[1] = {["Top"] = GameTooltipTooltip:CreateLine(), ["Center"] = GameTooltipTooltip:CreateLine(), ["Bottom"] = GameTooltipTooltip:CreateLine()}, [2] = {["Top"] = GameTooltip:CreateLine(), ["Center"] = GameTooltip:CreateLine(), ["Bottom"] = GameTooltip:CreateLine()}}
for _, v in pairs(QTip.Frames.Lines) do
for kk, vv in pairs(v) do
vv:SetThickness(1)
if (kk == "Center") then vv:SetColorTexture(0.5, 0.5, 0.5, 1); else vv:SetColorTexture(1, 1, 1, 1); end
vv:SetShown(false)
end
end
end
function QTip.Functions.CreateEvents()
local Script1 = GameTooltipTooltip:GetScript("OnTooltipSetItem")
GameTooltipTooltip:SetScript("OnTooltipSetItem", function(Self, ...)
local Link = select(2, Self:GetItem())
if (Link) then
local _, _, _, _, _, itemClassID, itemSubClassID = GetItemInfoInstant(Link)
if (itemClassID == LE_ITEM_CLASS_MISCELLANEOUS and itemSubClassID == LE_ITEM_MISCELLANEOUS_OTHER) then
if (QTipPerDB.Enabled.Anima) then QTip.Functions.Update_Anima(1, Self); end
elseif (itemClassID == LE_ITEM_CLASS_WEAPON or itemClassID == LE_ITEM_CLASS_ARMOR) then
if (QTipPerDB.Enabled.EquipQ) then QTip.Functions.Update_Equipment(1, Self); end
end
end
if (Script1) then return Script1(Self, ...); end
end)
local Script2 = GameTooltipTooltip:GetScript("OnShow")
GameTooltipTooltip:SetScript("OnShow", function(Self, ...)
if (QTipPerDB.Enabled.Anima) then QTip.Functions.UpdateTooltip(); end
if (Script2) then return Script2(Self, ...); end
end)
local Script3 = GameTooltip:GetScript("OnTooltipSetItem")
GameTooltip:SetScript("OnTooltipSetItem", function(Self, ...)
local Link = select(2, Self:GetItem())
if (Link) then
local _, _, _, _, _, itemClassID, itemSubClassID = GetItemInfoInstant(Link)
if (itemClassID == LE_ITEM_CLASS_MISCELLANEOUS and itemSubClassID == LE_ITEM_MISCELLANEOUS_OTHER) then
if (QTipPerDB.Enabled.Anima) then QTip.Functions.Update_Anima(2, Self); end
elseif (itemClassID == LE_ITEM_CLASS_WEAPON or itemClassID == LE_ITEM_CLASS_ARMOR) then
local Owner = Self:GetOwner()
if (Owner) then
if (Owner.Quantity) then
local Name = Owner:GetParent():GetName()
if (Name) then
if (string.match(Name, "CovenantMissionFrame")) then
if (QTipPerDB.Enabled.EquipT) then QTip.Functions.Update_Equipment(2, Self); end
elseif (string.match(Name, "GarrisonLandingPage")) then
if (QTipPerDB.Enabled.EquipR) then QTip.Functions.Update_Equipment(2, Self); end
end
end
else
local Name = Owner:GetName()
if (Name and (string.match(Name, "ContainerFrame") or string.match(Name, "BankFrame") or string.match(Name, "Guild"))) then                           
if (QTipPerDB.Enabled.EquipB) then QTip.Functions.Update_Equipment(2, Self); end
else
Name = Owner:GetParent():GetName()
if (Name) then
if (string.match(Name, "AuctionHouseFrameScrollChild")) then
local Valid = true
for i = 1, Self:NumLines() do
local Text = _G["GameTooltipTextLeft"..i]:GetText()
if (Text == AUCTION_HOUSE_BUCKET_VARIATION_EQUIPMENT_TOOLTIP) then
Valid = nil
break
end
end
if (QTipPerDB.Enabled.EquipA and Valid) then QTip.Functions.Update_Equipment(2, Self); end
elseif (string.match(Name, "BlackMarketScrollFrame")) then
if (QTipPerDB.Enabled.EquipA) then QTip.Functions.Update_Equipment(2, Self); end
end
end
end
end
end
end
end
if (Script3) then return Script3(Self, ...); end
end)
GameTooltip:HookScript("OnHide", function(Self, ...)
QTip.Data.TooltipData = nil
QTip.Functions.HideLines()
end)
end
SLASH_QTIP1, SLASH_QTIP2 = "/qtip", "/qt"
function SlashCmdList.QTIP()
if InterfaceOptionsFrame:IsShown() then
InterfaceOptionsFrame:Hide()
else
InterfaceOptionsFrame_OpenToCategory(QTipOptions)
InterfaceOptionsFrame_OpenToCategory(QTipOptions)
end
end
QTip.Frames.Options = CreateFrame("Frame", "QTipOptions", InterfaceOptionsFramePanelContainer)
QTip.Frames.Event = CreateFrame("Frame")
QTip.Frames.Event:RegisterEvent("ADDON_LOADED")
QTip.Frames.Event:RegisterEvent("PLAYER_LOGIN")
QTip.Frames.Event:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
QTip.Frames.Event:RegisterEvent("BAG_UPDATE")
QTip.Frames.Event:RegisterEvent("PLAYERBANKSLOTS_CHANGED")
function QTip.Frames.Event:OnEvent(Event, Self, ...)
if (Event == "ADDON_LOADED") then
if (Self == "QTip") then
QTip.Frames.Event:UnregisterEvent("ADDON_LOADED")
QTip.Data.Title, QTip.Data.Version = GetAddOnMetadata(Self, "Title"), GetAddOnMetadata(Self, "Version")
print(" ")
print("|cffffe00a".."(".."|cffff7d0a"..QTip.Data.Title, "v"..QTip.Data.Version, "|cff69ccf0".."Loaded".."|cffffe00a"..")")
print("|cfff8f996"..SLASH_QTIP1..", "..SLASH_QTIP2)
print(" ")
end
end
if (Event == "PLAYER_LOGIN") then
QTip.Frames.Event:UnregisterEvent("PLAYER_LOGIN")
QTip.Functions.CreateData()
QTip.Functions.CreateFrames()
QTip.Functions.CreateEvents()
QTip.Functions.CreateOptions()
QTip.Frames.Options.name = QTip.Data.Title
InterfaceOptions_AddCategory(QTip.Frames.Options)
QTip.Frames.Options:Hide()
end
if (Event == "BAG_UPDATE" or Event == "PLAYERBANKSLOTS_CHANGED") then
QTip.Data.TooltipData = nil
end
end
QTip.Frames.Event:SetScript("OnEvent", QTip.Frames.Event.OnEvent)